#include <iostream>

using namespace std;

int main()
{
    int n,k,i,j,q,w,i2,j2;
    cin>>n;
    cin>>k;
    int resenje=0;
    int x[n+1][n+1];//matrica
    bool K [k+1];//pregled ponavljanje
    bool L [k+1];
    bool lepo;
    for(i=1; i<=k; i++)
      {

        K[i]=0;
        L[i]=0;
      }
    for(i=1; i<=n; i++)
        for(j=1; j<=n; j++)
        {
            cin>>x[i][j];
        }
    for(i=1; i<=n; i++)
    {

        for(j=1; j<=n; j++)
        {
            if(x[i][j]!=0)//kad pregledam, taj pravougaonik ce postati 0
            {
                if(K[x[i][j]]==0)// preskacem one koje sam vec pregledao a nije bio u pravoganiku
                {

                    K[x[i][j]]=1;
                    lepo=true;
                    for( q=i; q<=n; q++)
                    {
                        for(w=j; w<=n; w++)
                        {

                            if(x[i][j]==x[q][w])
                            {
                                i2=q;
                                j2=w;
                            }
                        }
                    }
                    for(q=i; q<=i2; q++)
                    {
                        for(w=j; w<=j2; w++)
                        {
                            if(x[q][w]!=x[i][j])
                            {
                                lepo=false;
                            }
                        }
                    }
                    if(lepo)
                    {

                        for(q=i; q<=i2; q++)
                        {
                            for(w=j; w<=j2; w++)
                            {
                                x[q][w]=0;
                            }
                        }
                        resenje++;
                    }
                    else
                    {
                        L[x[i][j]]=1;
                        for(q=i; q<=i2; q++)
                        {
                            for(w=j; w<=j2; w++)
                            {
                                if(x[q][w]==x[i2][j2])
                                    x[q][w]=0;
                            }
                        }
                    }

                    //pregled pravouganika
                }
                else
                {

                    if(L[x[i][j]]==0)
                    {

                    L[x[i][j]]=1;
                    resenje--;
                    }
                    x[i][j]=0;
                }

            }
         /*   cout << resenje << endl;
            for(q=1; q<=n; q++)
            {
                for(w=1; w<=n; w++)
                {
                    cout<<x[q][w]<<" ";
                }
                cout<<endl;
            }*/
        }
    }
    cout << resenje << endl;
    return 0;
}